create database CsdlSPJ_Data
use CsdlSPJ_Data
create table NCC(
	MaNCC		char(10),
	Ten			varchar(30),
	Heso			int,
	ThPho		varchar(20),
	constraint NCC_PK primary key (MaNCC)
);

create table VATTU (
	MaVT			char(10),
	Ten			varchar(50),
	Mau			varchar(30),
	TrLuong		float,
	ThPho		varchar(20),
	constraint VATTU_PK primary key (MaVT)
);

create table DUAN (
	MaDA			char(10),
	Ten			varchar(30),
	ThPho		varchar(20),
	constraint DUAN_PK primary key (MaDA)
);

create table CUNGCAP (
	MaNCC		char(10),
	MaVT			char(10),
	MaDA			char(10),
	SLuong		int,
	constraint CUNGCAP_PK primary key (MaNCC, MaVT, MaDA),
	constraint CUNGCAP_FK_NCC foreign key (MaNCC) references NCC (MaNCC),
	constraint CUNGCAP_FK_VATTU foreign key (MaVT) references VATTU (MaVT),
	constraint CUNGCAP_FK_DUAN foreign key (MaDA) references DUAN (MaDA),
);

-- chen du lieu moi vao bang NCC
insert into NCC values ('S1', 'Son', 20, 'TpHCM');
insert into NCC values ('S2', 'Tran', 10, 'Ha Noi');
insert into NCC values ('S3', 'Bach', 30, 'Ha Noi');
insert into NCC values ('S4', 'Lap', 20, 'TpHCM');
insert into NCC values ('S5', 'Anh', 30, 'Da Nang');

-- chen du lieu moi vao bang VATTU
insert into VATTU values ('P1', 'Dai oc', 'Do', 12., 'TpHCM');
insert into VATTU values ('P2', 'Bu long', 'Xanh la', 17., 'Ha Noi');
insert into VATTU values ('P3', 'Dinh vit', 'Xanh duong', 17., 'Hai Phong');
insert into VATTU values ('P4', 'Dinh vit', 'Do', 14., 'TpHCM');
insert into VATTU values ('P5', 'Cam', 'Xanh duong', 12., 'Ha Noi');
insert into VATTU values ('P6', 'Banh rang', 'Do', 19., 'TpHCM');

-- chen du lieu moi vao bang DUAN
insert into DUAN values ('J1', 'May phan loai', 'Ha Noi');
insert into DUAN values ('J2', 'Man hinh', 'Viet Tri');
insert into DUAN values ('J3', 'OCR', 'Da Nang');
insert into DUAN values ('J4', 'Bang dieu khien', 'Da Nang');
insert into DUAN values ('J5', 'RAID', 'TpHCM');
insert into DUAN values ('J6', 'EDS', 'Hai Phong');
insert into DUAN values ('J7', 'Bang tu', 'TpHCM');

-- chen du lieu moi vao bang CUNGCAP
insert into CUNGCAP values ('S1', 'P1', 'J1', 200);
insert into CUNGCAP values ('S1', 'P1', 'J4', 700);
insert into CUNGCAP values ('S2', 'P3', 'J1', 400);
insert into CUNGCAP values ('S2', 'P3', 'J2', 200);
insert into CUNGCAP values ('S2', 'P3', 'J3', 200);
insert into CUNGCAP values ('S2', 'P3', 'J4', 500);
insert into CUNGCAP values ('S2', 'P3', 'J5', 600);
insert into CUNGCAP values ('S2', 'P3', 'J6', 400);
insert into CUNGCAP values ('S2', 'P3', 'J7', 800);
insert into CUNGCAP values ('S2', 'P5', 'J2', 200);
insert into CUNGCAP values ('S3', 'P3', 'J1', 200);
insert into CUNGCAP values ('S3', 'P4', 'J2', 500);
insert into CUNGCAP values ('S4', 'P6', 'J3', 300);
insert into CUNGCAP values ('S4', 'P6', 'J7', 300);
insert into CUNGCAP values ('S5', 'P2', 'J2', 200);
insert into CUNGCAP values ('S5', 'P2', 'J4', 100);
insert into CUNGCAP values ('S5', 'P5', 'J5', 500);
insert into CUNGCAP values ('S5', 'P5', 'J7', 100);
insert into CUNGCAP values ('S5', 'P6', 'J2', 200);
insert into CUNGCAP values ('S5', 'P1', 'J4', 100);
insert into CUNGCAP values ('S5', 'P3', 'J4', 200);
insert into CUNGCAP values ('S5', 'P4', 'J4', 800);
insert into CUNGCAP values ('S5', 'P5', 'J4', 400);
insert into CUNGCAP values ('S5', 'P6', 'J4', 500);

--cau 1
select Mau,ThPho,Ten
from VATTU 
where TrLuong>10 and ThPho not in(select ThPho
					from VATTU
					where ThPho like 'Ha Noi')
--cau 2
select *
from DUAN
--cau 3
select DA.*
from DUAN as DA
where ThPho like 'TpHCM'
--cau 4
select NCC.MaNCC,NCC.Ten,MaDA
from NCC, CUNGCAP as CC
where NCC.MaNCC=CC.MaNCC and MaDA='J1'
---cau5
select NCC.MaNCC,NCC.Ten as TenNCC,VT.MaVT,VT.Ten as TenVT,SLuong
from NCC, VATTU as VT, CUNGCAP as CC
where NCC.MaNCC=CC.MaNCC and VT.MaVT=CC.MaVT and (SLuong between 300 and 750)
---cau 6
select distinct VT.*
from VATTU as VT,NCC, CUNGCAP as CC
where NCC.MaNCC=CC.MaNCC and VT.MaVT=CC.MaVT and NCC.ThPho ='TpHCM'
---cau 7
select CC.MaVT
from NCC, CUNGCAP as CC, DUAN as DA
where NCC.MaNCC=CC.MaNCC and DA.MaDA=CC.MaDA and NCC.ThPho='TpHCM' and DA.ThPho='TpHCM'
---cau 8
select distinct NCC.ThPho, VT.ThPho
from NCC, CUNGCAP as CC, VATTU as VT
where NCC.MaNCC=CC.MaNCC and CC.MaVT=VT.MaVT
---cau 9
select distinct NCC.ThPho, DA.ThPho
from NCC, CUNGCAP as CC, DUAN as DA
where NCC.MaNCC=CC.MaNCC and CC.MaDA=DA.MaDA
---cau 10
select distinct N1.MaNCC,N2.MaNCC
from NCC as N1, NCC as N2
where N1.ThPho=N2.ThPho
and N1.MaNCC < N2.MaNCC
---cau 11
select distinct VT.*
from NCC, CUNGCAP as CC, DUAN as DA, VATTU as VT
where NCC.MaNCC=CC.MaNCC and CC.MaDA=DA.MaDA and CC.MaVT=VT.MaVT
				and NCC.ThPho=DA.ThPho
---cau 12
select DA.MaDA, DA.Ten
from NCC, CUNGCAP as CC,DUAN as DA
where 

---cau 13

---cau 14sai
select distinct CC.MaVT,count(*) as dem
from NCC, CUNGCAP as CC
where NCC.MaNCC=CC.MaNCC
group by CC.MaVT
having count(*)>1 
---cau 15
select distinct CC.MaVT, sum(CC.SLuong) as tongsoluong
from CUNGCAP as CC
group by CC.MaVT
---cau 16
select count(MaDA) as Tongduan
from CUNGCAP
where MaNCC='S1'
---cau 17
select  sum(SLuong) as Tongsoluong
from CUNGCAP as CC, VATTU as VT
where CC.MaVT=VT.MaVT and CC.MaNCC='S1' and VT.MaVT='P1'
---cau 18
select VT.Ten as TenVT,VT.MaVT,DA.Ten as TenDA,DA.MaDA,sum(SLuong) as Tongsoluong
from CUNGCAP as CC, DUAN as DA, VATTU as VT
where CC.MaVT=VT.MaVT and CC.MaDA=DA.MaDA
group by VT.Ten,VT.MaVT,DA.Ten,DA.MaDA
---cau 19
select VT.Ten as TenVT,VT.MaVT,DA.Ten as TenDA,avg(SLuong)as TBLuong
from VATTU as VT, DUAN as DA, CUNGCAP as CC
where CC.MaVT=VT.MaVT and CC.MaDA=DA.MaDA 
group by VT.Ten, VT.MaVT,DA.Ten
having avg(SLuong)> 350
---cau 20
select DA.MaDA,DA.Ten
from CUNGCAP as CC, DUAN as DA
where CC.MaDA=DA.MaDA and CC.MaNCC='S1'
---cau 21
select distinct VT.Mau
from CUNGCAP as CC, VATTU as VT
where CC.MaVT=VT.MaVT and CC.MaNCC='S1'
---cau 22
select VT.MaVT,VT.Ten
from CUNGCAP as CC, VATTU as VT, DUAN as DA
where CC.MaVT=VT.MaVT and CC.MaDA=DA.MaDA and DA.ThPho='TpHCM' 
---cau 23
select DA.MaDA,DA.Ten
from CUNGCAP as CC, DUAN as DA
where CC.MaDA=DA.MaDselect(DA.MaDA
					from CUNGCAP as CC
					